XCB Dbe API

Dbe XCB Protocol Implementation. More...

## Data Structures

struct | xcb_dbe_back_buffer_iterator_t
| xcb_dbe_back_buffer_iterator_t More...
struct | xcb_dbe_swap_info_t
| xcb_dbe_swap_info_t More...
struct | xcb_dbe_swap_info_iterator_t
| xcb_dbe_swap_info_iterator_t More...
struct | xcb_dbe_buffer_attributes_t
| xcb_dbe_buffer_attributes_t More...
struct | xcb_dbe_buffer_attributes_iterator_t
| xcb_dbe_buffer_attributes_iterator_t More...
struct | xcb_dbe_visual_info_t
| xcb_dbe_visual_info_t More...
struct | xcb_dbe_visual_info_iterator_t
| xcb_dbe_visual_info_iterator_t More...
struct | xcb_dbe_visual_infos_t
| xcb_dbe_visual_infos_t More...
struct | xcb_dbe_visual_infos_iterator_t
| xcb_dbe_visual_infos_iterator_t More...
struct | xcb_dbe_bad_buffer_error_t
| xcb_dbe_bad_buffer_error_t More...
struct | xcb_dbe_query_version_cookie_t
| xcb_dbe_query_version_cookie_t More...
struct | xcb_dbe_query_version_request_t
| xcb_dbe_query_version_request_t More...
struct | xcb_dbe_query_version_reply_t
| xcb_dbe_query_version_reply_t More...
struct | xcb_dbe_allocate_back_buffer_request_t
| xcb_dbe_allocate_back_buffer_request_t More...
struct | xcb_dbe_deallocate_back_buffer_request_t
| xcb_dbe_deallocate_back_buffer_request_t More...
struct | xcb_dbe_swap_buffers_request_t
| xcb_dbe_swap_buffers_request_t More...
struct | xcb_dbe_begin_idiom_request_t
| xcb_dbe_begin_idiom_request_t More...
struct | xcb_dbe_end_idiom_request_t
| xcb_dbe_end_idiom_request_t More...
struct | xcb_dbe_get_visual_info_cookie_t
| xcb_dbe_get_visual_info_cookie_t More...
struct | xcb_dbe_get_visual_info_request_t
| xcb_dbe_get_visual_info_request_t More...
struct | xcb_dbe_get_visual_info_reply_t
| xcb_dbe_get_visual_info_reply_t More...
struct | xcb_dbe_get_back_buffer_attributes_cookie_t
| xcb_dbe_get_back_buffer_attributes_cookie_t More...
struct | xcb_dbe_get_back_buffer_attributes_request_t
| xcb_dbe_get_back_buffer_attributes_request_t More...
struct | xcb_dbe_get_back_buffer_attributes_reply_t
| xcb_dbe_get_back_buffer_attributes_reply_t More...

## Macros

#define | XCB_DBE_MAJOR_VERSION 1
#define | XCB_DBE_MINOR_VERSION 0
#define | XCB_DBE_BAD_BUFFER 0
#define | XCB_DBE_QUERY_VERSION 0
#define | XCB_DBE_ALLOCATE_BACK_BUFFER 1
#define | XCB_DBE_DEALLOCATE_BACK_BUFFER 2
#define | XCB_DBE_SWAP_BUFFERS 3
#define | XCB_DBE_BEGIN_IDIOM 4
#define | XCB_DBE_END_IDIOM 5
#define | XCB_DBE_GET_VISUAL_INFO 6
#define | XCB_DBE_GET_BACK_BUFFER_ATTRIBUTES 7

## Typedefs

typedef uint32_t | xcb_dbe_back_buffer_t
typedef struct xcb_dbe_back_buffer_iterator_t | xcb_dbe_back_buffer_iterator_t
| xcb_dbe_back_buffer_iterator_t
typedef enum xcb_dbe_swap_action_t | xcb_dbe_swap_action_t
typedef struct xcb_dbe_swap_info_t | xcb_dbe_swap_info_t
| xcb_dbe_swap_info_t
typedef struct xcb_dbe_swap_info_iterator_t | xcb_dbe_swap_info_iterator_t
| xcb_dbe_swap_info_iterator_t
typedef struct xcb_dbe_buffer_attributes_t | xcb_dbe_buffer_attributes_t
| xcb_dbe_buffer_attributes_t
typedef struct xcb_dbe_buffer_attributes_iterator_t | xcb_dbe_buffer_attributes_iterator_t
| xcb_dbe_buffer_attributes_iterator_t
typedef struct xcb_dbe_visual_info_t | xcb_dbe_visual_info_t
| xcb_dbe_visual_info_t
typedef struct xcb_dbe_visual_info_iterator_t | xcb_dbe_visual_info_iterator_t
| xcb_dbe_visual_info_iterator_t
typedef struct xcb_dbe_visual_infos_t | xcb_dbe_visual_infos_t
| xcb_dbe_visual_infos_t
typedef struct xcb_dbe_visual_infos_iterator_t | xcb_dbe_visual_infos_iterator_t
| xcb_dbe_visual_infos_iterator_t
typedef struct xcb_dbe_bad_buffer_error_t | xcb_dbe_bad_buffer_error_t
| xcb_dbe_bad_buffer_error_t
typedef struct xcb_dbe_query_version_cookie_t | xcb_dbe_query_version_cookie_t
| xcb_dbe_query_version_cookie_t
typedef struct xcb_dbe_query_version_request_t | xcb_dbe_query_version_request_t
| xcb_dbe_query_version_request_t
typedef struct xcb_dbe_query_version_reply_t | xcb_dbe_query_version_reply_t
| xcb_dbe_query_version_reply_t
typedef struct xcb_dbe_allocate_back_buffer_request_t | xcb_dbe_allocate_back_buffer_request_t
| xcb_dbe_allocate_back_buffer_request_t
typedef struct xcb_dbe_deallocate_back_buffer_request_t | xcb_dbe_deallocate_back_buffer_request_t
| xcb_dbe_deallocate_back_buffer_request_t
typedef struct xcb_dbe_swap_buffers_request_t | xcb_dbe_swap_buffers_request_t
| xcb_dbe_swap_buffers_request_t
typedef struct xcb_dbe_begin_idiom_request_t | xcb_dbe_begin_idiom_request_t
| xcb_dbe_begin_idiom_request_t
typedef struct xcb_dbe_end_idiom_request_t | xcb_dbe_end_idiom_request_t
| xcb_dbe_end_idiom_request_t
typedef struct xcb_dbe_get_visual_info_cookie_t | xcb_dbe_get_visual_info_cookie_t
| xcb_dbe_get_visual_info_cookie_t
typedef struct xcb_dbe_get_visual_info_request_t | xcb_dbe_get_visual_info_request_t
| xcb_dbe_get_visual_info_request_t
typedef struct xcb_dbe_get_visual_info_reply_t | xcb_dbe_get_visual_info_reply_t
| xcb_dbe_get_visual_info_reply_t
typedef struct xcb_dbe_get_back_buffer_attributes_cookie_t | xcb_dbe_get_back_buffer_attributes_cookie_t
| xcb_dbe_get_back_buffer_attributes_cookie_t
typedef struct xcb_dbe_get_back_buffer_attributes_request_t | xcb_dbe_get_back_buffer_attributes_request_t
| xcb_dbe_get_back_buffer_attributes_request_t
typedef struct xcb_dbe_get_back_buffer_attributes_reply_t | xcb_dbe_get_back_buffer_attributes_reply_t
| xcb_dbe_get_back_buffer_attributes_reply_t

## Enumerations

enum | xcb_dbe_swap_action_t { XCB_DBE_SWAP_ACTION_UNDEFINED = 0 , XCB_DBE_SWAP_ACTION_BACKGROUND = 1 , XCB_DBE_SWAP_ACTION_UNTOUCHED = 2 , XCB_DBE_SWAP_ACTION_COPIED = 3 }

## Functions

void | xcb_dbe_back_buffer_next (xcb_dbe_back_buffer_iterator_t *i)
xcb_generic_iterator_t | xcb_dbe_back_buffer_end (xcb_dbe_back_buffer_iterator_t i)
void | xcb_dbe_swap_info_next (xcb_dbe_swap_info_iterator_t *i)
xcb_generic_iterator_t | xcb_dbe_swap_info_end (xcb_dbe_swap_info_iterator_t i)
void | xcb_dbe_buffer_attributes_next (xcb_dbe_buffer_attributes_iterator_t *i)
xcb_generic_iterator_t | xcb_dbe_buffer_attributes_end (xcb_dbe_buffer_attributes_iterator_t i)
void | xcb_dbe_visual_info_next (xcb_dbe_visual_info_iterator_t *i)
xcb_generic_iterator_t | xcb_dbe_visual_info_end (xcb_dbe_visual_info_iterator_t i)
int | xcb_dbe_visual_infos_sizeof (const void *_buffer)
xcb_dbe_visual_info_t * | xcb_dbe_visual_infos_infos (const xcb_dbe_visual_infos_t *R)
int | xcb_dbe_visual_infos_infos_length (const xcb_dbe_visual_infos_t *R)
xcb_dbe_visual_info_iterator_t | xcb_dbe_visual_infos_infos_iterator (const xcb_dbe_visual_infos_t *R)
void | xcb_dbe_visual_infos_next (xcb_dbe_visual_infos_iterator_t *i)
xcb_generic_iterator_t | xcb_dbe_visual_infos_end (xcb_dbe_visual_infos_iterator_t i)
xcb_dbe_query_version_cookie_t | xcb_dbe_query_version (xcb_connection_t *c, uint8_t major_version, uint8_t minor_version)
| Queries the version of this extension.
xcb_dbe_query_version_cookie_t | xcb_dbe_query_version_unchecked (xcb_connection_t *c, uint8_t major_version, uint8_t minor_version)
| Queries the version of this extension.
xcb_dbe_query_version_reply_t * | xcb_dbe_query_version_reply (xcb_connection_t *c, xcb_dbe_query_version_cookie_t cookie, xcb_generic_error_t **e)
xcb_void_cookie_t | xcb_dbe_allocate_back_buffer_checked (xcb_connection_t *c, xcb_window_t window, xcb_dbe_back_buffer_t buffer, uint8_t swap_action)
| Allocates a back buffer.
xcb_void_cookie_t | xcb_dbe_allocate_back_buffer (xcb_connection_t *c, xcb_window_t window, xcb_dbe_back_buffer_t buffer, uint8_t swap_action)
| Allocates a back buffer.
xcb_void_cookie_t | xcb_dbe_deallocate_back_buffer_checked (xcb_connection_t *c, xcb_dbe_back_buffer_t buffer)
| Deallocates a back buffer.
xcb_void_cookie_t | xcb_dbe_deallocate_back_buffer (xcb_connection_t *c, xcb_dbe_back_buffer_t buffer)
| Deallocates a back buffer.
int | xcb_dbe_swap_buffers_sizeof (const void *_buffer)
xcb_void_cookie_t | xcb_dbe_swap_buffers_checked (xcb_connection_t *c, uint32_t n_actions, const xcb_dbe_swap_info_t *actions)
| Swaps front and back buffers.
xcb_void_cookie_t | xcb_dbe_swap_buffers (xcb_connection_t *c, uint32_t n_actions, const xcb_dbe_swap_info_t *actions)
| Swaps front and back buffers.
xcb_dbe_swap_info_t * | xcb_dbe_swap_buffers_actions (const xcb_dbe_swap_buffers_request_t *R)
int | xcb_dbe_swap_buffers_actions_length (const xcb_dbe_swap_buffers_request_t *R)
xcb_dbe_swap_info_iterator_t | xcb_dbe_swap_buffers_actions_iterator (const xcb_dbe_swap_buffers_request_t *R)
xcb_void_cookie_t | xcb_dbe_begin_idiom_checked (xcb_connection_t *c)
| Begins a logical swap block.
xcb_void_cookie_t | xcb_dbe_begin_idiom (xcb_connection_t *c)
| Begins a logical swap block.
xcb_void_cookie_t | xcb_dbe_end_idiom_checked (xcb_connection_t *c)
| Ends a logical swap block.
xcb_void_cookie_t | xcb_dbe_end_idiom (xcb_connection_t *c)
| Ends a logical swap block.
int | xcb_dbe_get_visual_info_sizeof (const void *_buffer)
xcb_dbe_get_visual_info_cookie_t | xcb_dbe_get_visual_info (xcb_connection_t *c, uint32_t n_drawables, const xcb_drawable_t *drawables)
| Requests visuals that support double buffering.
xcb_dbe_get_visual_info_cookie_t | xcb_dbe_get_visual_info_unchecked (xcb_connection_t *c, uint32_t n_drawables, const xcb_drawable_t *drawables)
| Requests visuals that support double buffering.
int | xcb_dbe_get_visual_info_supported_visuals_length (const xcb_dbe_get_visual_info_reply_t *R)
xcb_dbe_visual_infos_iterator_t | xcb_dbe_get_visual_info_supported_visuals_iterator (const xcb_dbe_get_visual_info_reply_t *R)
xcb_dbe_get_visual_info_reply_t * | xcb_dbe_get_visual_info_reply (xcb_connection_t *c, xcb_dbe_get_visual_info_cookie_t cookie, xcb_generic_error_t **e)
xcb_dbe_get_back_buffer_attributes_cookie_t | xcb_dbe_get_back_buffer_attributes (xcb_connection_t *c, xcb_dbe_back_buffer_t buffer)
| Gets back buffer attributes.
xcb_dbe_get_back_buffer_attributes_cookie_t | xcb_dbe_get_back_buffer_attributes_unchecked (xcb_connection_t *c, xcb_dbe_back_buffer_t buffer)
| Gets back buffer attributes.
xcb_dbe_get_back_buffer_attributes_reply_t * | xcb_dbe_get_back_buffer_attributes_reply (xcb_connection_t *c, xcb_dbe_get_back_buffer_attributes_cookie_t cookie, xcb_generic_error_t **e)

## Variables

xcb_extension_t | xcb_dbe_id

## Detailed Description

Dbe XCB Protocol Implementation.

## Macro Definition Documentation

## XCB_DBE_ALLOCATE_BACK_BUFFER

#define XCB_DBE_ALLOCATE_BACK_BUFFER 1

Opcode for xcb_dbe_allocate_back_buffer.

Referenced by xcb_dbe_allocate_back_buffer(), and xcb_dbe_allocate_back_buffer_checked().

## XCB_DBE_BAD_BUFFER

#define XCB_DBE_BAD_BUFFER 0

Opcode for xcb_dbe_bad_buffer.

## XCB_DBE_BEGIN_IDIOM

#define XCB_DBE_BEGIN_IDIOM 4

Opcode for xcb_dbe_begin_idiom.

Referenced by xcb_dbe_begin_idiom(), and xcb_dbe_begin_idiom_checked().

## XCB_DBE_DEALLOCATE_BACK_BUFFER

#define XCB_DBE_DEALLOCATE_BACK_BUFFER 2

Opcode for xcb_dbe_deallocate_back_buffer.

Referenced by xcb_dbe_deallocate_back_buffer(), and xcb_dbe_deallocate_back_buffer_checked().

## XCB_DBE_END_IDIOM

#define XCB_DBE_END_IDIOM 5

Opcode for xcb_dbe_end_idiom.

Referenced by xcb_dbe_end_idiom(), and xcb_dbe_end_idiom_checked().

## XCB_DBE_GET_BACK_BUFFER_ATTRIBUTES

#define XCB_DBE_GET_BACK_BUFFER_ATTRIBUTES 7

Opcode for xcb_dbe_get_back_buffer_attributes.

Referenced by xcb_dbe_get_back_buffer_attributes(), and xcb_dbe_get_back_buffer_attributes_unchecked().

## XCB_DBE_GET_VISUAL_INFO

#define XCB_DBE_GET_VISUAL_INFO 6

Opcode for xcb_dbe_get_visual_info.

Referenced by xcb_dbe_get_visual_info(), and xcb_dbe_get_visual_info_unchecked().

## XCB_DBE_QUERY_VERSION

#define XCB_DBE_QUERY_VERSION 0

Opcode for xcb_dbe_query_version.

Referenced by xcb_dbe_query_version(), and xcb_dbe_query_version_unchecked().

## XCB_DBE_SWAP_BUFFERS

#define XCB_DBE_SWAP_BUFFERS 3

Opcode for xcb_dbe_swap_buffers.

Referenced by xcb_dbe_swap_buffers(), and xcb_dbe_swap_buffers_checked().

## Enumeration Type Documentation

## xcb_dbe_swap_action_t

enum xcb_dbe_swap_action_t

Enumerator
XCB_DBE_SWAP_ACTION_UNDEFINED | Discard the buffer. The buffer may be reallocated and end up with random VRAM content.
XCB_DBE_SWAP_ACTION_BACKGROUND | Erase with window background.
XCB_DBE_SWAP_ACTION_UNTOUCHED | Leave untouched.
XCB_DBE_SWAP_ACTION_COPIED | Copy the newly displayed front buffer.

## Function Documentation

## xcb_dbe_allocate_back_buffer()

xcb_void_cookie_t xcb_dbe_allocate_back_buffer | ( | xcb_connection_t * | c,
|  | xcb_window_t | window,
|  | xcb_dbe_back_buffer_t | buffer,
|  | uint8_t | swap_action )

Allocates a back buffer.

Parameters

  c | The connection
  window | The window to which to add the back buffer.
  buffer | The buffer id to associate with the back buffer.
  swap_action | The swap action most likely to be used to present this back buffer. This is only a hint, and does not preclude the use of other swap actions.

Returns
  A cookie

Associates buffer with the back buffer of window. Multiple ids may be associated with the back buffer, which is created by the first allocate call and destroyed by the last deallocate.

References XCB_DBE_ALLOCATE_BACK_BUFFER.

## xcb_dbe_allocate_back_buffer_checked()

xcb_void_cookie_t xcb_dbe_allocate_back_buffer_checked | ( | xcb_connection_t * | c,
|  | xcb_window_t | window,
|  | xcb_dbe_back_buffer_t | buffer,
|  | uint8_t | swap_action )

Allocates a back buffer.

Parameters

  c | The connection
  window | The window to which to add the back buffer.
  buffer | The buffer id to associate with the back buffer.
  swap_action | The swap action most likely to be used to present this back buffer. This is only a hint, and does not preclude the use of other swap actions.

Returns
  A cookie

Associates buffer with the back buffer of window. Multiple ids may be associated with the back buffer, which is created by the first allocate call and destroyed by the last deallocate.

This form can be used only if the request will not cause a reply to be generated. Any returned error will be saved for handling by xcb_request_check().

References XCB_DBE_ALLOCATE_BACK_BUFFER.

## xcb_dbe_back_buffer_end()

xcb_generic_iterator_t xcb_dbe_back_buffer_end | ( | xcb_dbe_back_buffer_iterator_t | i | ) |

Return the iterator pointing to the last element

Parameters

  i | An xcb_dbe_back_buffer_iterator_t

Returns
  The iterator pointing to the last element

Set the current element in the iterator to the last element. The member rem is set to 0. The member data points to the last element.

References xcb_generic_iterator_t::data, xcb_generic_iterator_t::index, and xcb_generic_iterator_t::rem.

## xcb_dbe_back_buffer_next()

void xcb_dbe_back_buffer_next | ( | xcb_dbe_back_buffer_iterator_t * | i | ) |

Get the next element of the iterator

Parameters

  i | Pointer to a xcb_dbe_back_buffer_iterator_t

Get the next element in the iterator. The member rem is decreased by one. The member data points to the next element. The member index is increased by sizeof(xcb_dbe_back_buffer_t)

## xcb_dbe_begin_idiom()

xcb_void_cookie_t xcb_dbe_begin_idiom | ( | xcb_connection_t * | c | ) |

Begins a logical swap block.

Parameters

  c | The connection

Returns
  A cookie

Creates a block of operations intended to occur together. This may be needed if window presentation requires changing buffers unknown to this extension, such as depth or stencil buffers.

References XCB_DBE_BEGIN_IDIOM.

## xcb_dbe_begin_idiom_checked()

xcb_void_cookie_t xcb_dbe_begin_idiom_checked | ( | xcb_connection_t * | c | ) |

Begins a logical swap block.

Parameters

  c | The connection

Returns
  A cookie

Creates a block of operations intended to occur together. This may be needed if window presentation requires changing buffers unknown to this extension, such as depth or stencil buffers.

This form can be used only if the request will not cause a reply to be generated. Any returned error will be saved for handling by xcb_request_check().

References XCB_DBE_BEGIN_IDIOM.

## xcb_dbe_buffer_attributes_end()

xcb_generic_iterator_t xcb_dbe_buffer_attributes_end | ( | xcb_dbe_buffer_attributes_iterator_t | i | ) |

Return the iterator pointing to the last element

Parameters

  i | An xcb_dbe_buffer_attributes_iterator_t

Returns
  The iterator pointing to the last element

Set the current element in the iterator to the last element. The member rem is set to 0. The member data points to the last element.

References xcb_generic_iterator_t::data, xcb_generic_iterator_t::index, and xcb_generic_iterator_t::rem.

## xcb_dbe_buffer_attributes_next()

void xcb_dbe_buffer_attributes_next | ( | xcb_dbe_buffer_attributes_iterator_t * | i | ) |

Get the next element of the iterator

Parameters

  i | Pointer to a xcb_dbe_buffer_attributes_iterator_t

Get the next element in the iterator. The member rem is decreased by one. The member data points to the next element. The member index is increased by sizeof(xcb_dbe_buffer_attributes_t)

## xcb_dbe_deallocate_back_buffer()

xcb_void_cookie_t xcb_dbe_deallocate_back_buffer | ( | xcb_connection_t * | c,
|  | xcb_dbe_back_buffer_t | buffer )

Deallocates a back buffer.

Parameters

  c | The connection
  buffer | The back buffer to deallocate.

Returns
  A cookie

Deallocates the given buffer. If buffer is an invalid id, a BadBuffer error is returned. Because a window may have allocated multiple back buffer ids, the back buffer itself is not deleted until all these ids are deallocated by this call.

References XCB_DBE_DEALLOCATE_BACK_BUFFER.

## xcb_dbe_deallocate_back_buffer_checked()

xcb_void_cookie_t xcb_dbe_deallocate_back_buffer_checked | ( | xcb_connection_t * | c,
|  | xcb_dbe_back_buffer_t | buffer )

Deallocates a back buffer.

Parameters

  c | The connection
  buffer | The back buffer to deallocate.

Returns
  A cookie

Deallocates the given buffer. If buffer is an invalid id, a BadBuffer error is returned. Because a window may have allocated multiple back buffer ids, the back buffer itself is not deleted until all these ids are deallocated by this call.

This form can be used only if the request will not cause a reply to be generated. Any returned error will be saved for handling by xcb_request_check().

References XCB_DBE_DEALLOCATE_BACK_BUFFER.

## xcb_dbe_end_idiom()

xcb_void_cookie_t xcb_dbe_end_idiom | ( | xcb_connection_t * | c | ) |

Ends a logical swap block.

Parameters

  c | The connection

Returns
  A cookie

No description yet

References XCB_DBE_END_IDIOM.

## xcb_dbe_end_idiom_checked()

xcb_void_cookie_t xcb_dbe_end_idiom_checked | ( | xcb_connection_t * | c | ) |

Ends a logical swap block.

Parameters

  c | The connection

Returns
  A cookie

No description yet

This form can be used only if the request will not cause a reply to be generated. Any returned error will be saved for handling by xcb_request_check().

References XCB_DBE_END_IDIOM.

## xcb_dbe_get_back_buffer_attributes()

xcb_dbe_get_back_buffer_attributes_cookie_t xcb_dbe_get_back_buffer_attributes | ( | xcb_connection_t * | c,
|  | xcb_dbe_back_buffer_t | buffer )

Gets back buffer attributes.

Parameters

  c | The connection
  buffer | The back buffer to query.

Returns
  A cookie

Returns the attributes of the specified buffer.

References XCB_DBE_GET_BACK_BUFFER_ATTRIBUTES.

## xcb_dbe_get_back_buffer_attributes_reply()

xcb_dbe_get_back_buffer_attributes_reply_t * xcb_dbe_get_back_buffer_attributes_reply | ( | xcb_connection_t * | c,
|  | xcb_dbe_get_back_buffer_attributes_cookie_t | cookie,
|  | xcb_generic_error_t ** | e )

Return the reply

Parameters

  c | The connection
  cookie | The cookie
  e | The xcb_generic_error_t supplied

Returns the reply of the request asked by

The parameter `e` supplied to this function must be NULL if xcb_dbe_get_back_buffer_attributes_unchecked(). is used. Otherwise, it stores the error if any.

The returned value must be freed by the caller using free().

## xcb_dbe_get_back_buffer_attributes_unchecked()

xcb_dbe_get_back_buffer_attributes_cookie_t xcb_dbe_get_back_buffer_attributes_unchecked | ( | xcb_connection_t * | c,
|  | xcb_dbe_back_buffer_t | buffer )

Gets back buffer attributes.

Parameters

  c | The connection
  buffer | The back buffer to query.

Returns
  A cookie

Returns the attributes of the specified buffer.

This form can be used only if the request will cause a reply to be generated. Any returned error will be placed in the event queue.

References XCB_DBE_GET_BACK_BUFFER_ATTRIBUTES.

## xcb_dbe_get_visual_info()

xcb_dbe_get_visual_info_cookie_t xcb_dbe_get_visual_info | ( | xcb_connection_t * | c,
|  | uint32_t | n_drawables,
|  | const xcb_drawable_t * | drawables )

Requests visuals that support double buffering.

Parameters

  c | The connection

Returns
  A cookie

No description yet

References XCB_DBE_GET_VISUAL_INFO.

## xcb_dbe_get_visual_info_reply()

xcb_dbe_get_visual_info_reply_t * xcb_dbe_get_visual_info_reply | ( | xcb_connection_t * | c,
|  | xcb_dbe_get_visual_info_cookie_t | cookie,
|  | xcb_generic_error_t ** | e )

Return the reply

Parameters

  c | The connection
  cookie | The cookie
  e | The xcb_generic_error_t supplied

Returns the reply of the request asked by

The parameter `e` supplied to this function must be NULL if xcb_dbe_get_visual_info_unchecked(). is used. Otherwise, it stores the error if any.

The returned value must be freed by the caller using free().

## xcb_dbe_get_visual_info_unchecked()

xcb_dbe_get_visual_info_cookie_t xcb_dbe_get_visual_info_unchecked | ( | xcb_connection_t * | c,
|  | uint32_t | n_drawables,
|  | const xcb_drawable_t * | drawables )

Requests visuals that support double buffering.

Parameters

  c | The connection

Returns
  A cookie

No description yet

This form can be used only if the request will cause a reply to be generated. Any returned error will be placed in the event queue.

References XCB_DBE_GET_VISUAL_INFO.

## xcb_dbe_query_version()

xcb_dbe_query_version_cookie_t xcb_dbe_query_version | ( | xcb_connection_t * | c,
|  | uint8_t | major_version,
|  | uint8_t | minor_version )

Queries the version of this extension.

Parameters

  c | The connection
  major_version | The major version of the extension. Check that it is compatible with the XCB_DBE_MAJOR_VERSION that your code is compiled with.
  minor_version | The minor version of the extension. Check that it is compatible with the XCB_DBE_MINOR_VERSION that your code is compiled with.

Returns
  A cookie

Queries the version of this extension. You must do this before using any functionality it provides.

References XCB_DBE_QUERY_VERSION.

## xcb_dbe_query_version_reply()

xcb_dbe_query_version_reply_t * xcb_dbe_query_version_reply | ( | xcb_connection_t * | c,
|  | xcb_dbe_query_version_cookie_t | cookie,
|  | xcb_generic_error_t ** | e )

Return the reply

Parameters

  c | The connection
  cookie | The cookie
  e | The xcb_generic_error_t supplied

Returns the reply of the request asked by

The parameter `e` supplied to this function must be NULL if xcb_dbe_query_version_unchecked(). is used. Otherwise, it stores the error if any.

The returned value must be freed by the caller using free().

## xcb_dbe_query_version_unchecked()

xcb_dbe_query_version_cookie_t xcb_dbe_query_version_unchecked | ( | xcb_connection_t * | c,
|  | uint8_t | major_version,
|  | uint8_t | minor_version )

Queries the version of this extension.

Parameters

  c | The connection
  major_version | The major version of the extension. Check that it is compatible with the XCB_DBE_MAJOR_VERSION that your code is compiled with.
  minor_version | The minor version of the extension. Check that it is compatible with the XCB_DBE_MINOR_VERSION that your code is compiled with.

Returns
  A cookie

Queries the version of this extension. You must do this before using any functionality it provides.

This form can be used only if the request will cause a reply to be generated. Any returned error will be placed in the event queue.

References XCB_DBE_QUERY_VERSION.

## xcb_dbe_swap_buffers()

xcb_void_cookie_t xcb_dbe_swap_buffers | ( | xcb_connection_t * | c,
|  | uint32_t | n_actions,
|  | const xcb_dbe_swap_info_t * | actions )

Swaps front and back buffers.

Parameters

  c | The connection
  n_actions | Number of swap actions in actions.
  actions | List of windows on which to swap buffers.

Returns
  A cookie

Swaps the front and back buffers on the specified windows. The front and back buffers retain their ids, so that the window id continues to refer to the front buffer, while the back buffer id created by this extension continues to refer to the back buffer. Back buffer contents is moved to the front buffer. Back buffer contents after the operation depends on the given swap action. The optimal swap action depends on how each frame is rendered. For example, if the buffer is cleared and fully overwritten on every frame, the "untouched" action, which throws away the buffer contents, would provide the best performance. To eliminate visual artifacts, the swap will occure during the monitor VSync, if the X server supports detecting it.

References XCB_DBE_SWAP_BUFFERS.

## xcb_dbe_swap_buffers_checked()

xcb_void_cookie_t xcb_dbe_swap_buffers_checked | ( | xcb_connection_t * | c,
|  | uint32_t | n_actions,
|  | const xcb_dbe_swap_info_t * | actions )

Swaps front and back buffers.

Parameters

  c | The connection
  n_actions | Number of swap actions in actions.
  actions | List of windows on which to swap buffers.

Returns
  A cookie

Swaps the front and back buffers on the specified windows. The front and back buffers retain their ids, so that the window id continues to refer to the front buffer, while the back buffer id created by this extension continues to refer to the back buffer. Back buffer contents is moved to the front buffer. Back buffer contents after the operation depends on the given swap action. The optimal swap action depends on how each frame is rendered. For example, if the buffer is cleared and fully overwritten on every frame, the "untouched" action, which throws away the buffer contents, would provide the best performance. To eliminate visual artifacts, the swap will occure during the monitor VSync, if the X server supports detecting it.

This form can be used only if the request will not cause a reply to be generated. Any returned error will be saved for handling by xcb_request_check().

References XCB_DBE_SWAP_BUFFERS.

## xcb_dbe_swap_info_end()

xcb_generic_iterator_t xcb_dbe_swap_info_end | ( | xcb_dbe_swap_info_iterator_t | i | ) |

Return the iterator pointing to the last element

Parameters

  i | An xcb_dbe_swap_info_iterator_t

Returns
  The iterator pointing to the last element

Set the current element in the iterator to the last element. The member rem is set to 0. The member data points to the last element.

References xcb_generic_iterator_t::data, xcb_generic_iterator_t::index, and xcb_generic_iterator_t::rem.

## xcb_dbe_swap_info_next()

void xcb_dbe_swap_info_next | ( | xcb_dbe_swap_info_iterator_t * | i | ) |

Get the next element of the iterator

Parameters

  i | Pointer to a xcb_dbe_swap_info_iterator_t

Get the next element in the iterator. The member rem is decreased by one. The member data points to the next element. The member index is increased by sizeof(xcb_dbe_swap_info_t)

## xcb_dbe_visual_info_end()

xcb_generic_iterator_t xcb_dbe_visual_info_end | ( | xcb_dbe_visual_info_iterator_t | i | ) |

Return the iterator pointing to the last element

Parameters

  i | An xcb_dbe_visual_info_iterator_t

Returns
  The iterator pointing to the last element

Set the current element in the iterator to the last element. The member rem is set to 0. The member data points to the last element.

References xcb_generic_iterator_t::data, xcb_generic_iterator_t::index, and xcb_generic_iterator_t::rem.

## xcb_dbe_visual_info_next()

void xcb_dbe_visual_info_next | ( | xcb_dbe_visual_info_iterator_t * | i | ) |

Get the next element of the iterator

Parameters

  i | Pointer to a xcb_dbe_visual_info_iterator_t

Get the next element in the iterator. The member rem is decreased by one. The member data points to the next element. The member index is increased by sizeof(xcb_dbe_visual_info_t)

## xcb_dbe_visual_infos_end()

xcb_generic_iterator_t xcb_dbe_visual_infos_end | ( | xcb_dbe_visual_infos_iterator_t | i | ) |

Return the iterator pointing to the last element

Parameters

  i | An xcb_dbe_visual_infos_iterator_t

Returns
  The iterator pointing to the last element

Set the current element in the iterator to the last element. The member rem is set to 0. The member data points to the last element.

References xcb_generic_iterator_t::data, xcb_generic_iterator_t::index, xcb_generic_iterator_t::rem, and xcb_dbe_visual_infos_next().

## xcb_dbe_visual_infos_next()

void xcb_dbe_visual_infos_next | ( | xcb_dbe_visual_infos_iterator_t * | i | ) |

Get the next element of the iterator

Parameters

  i | Pointer to a xcb_dbe_visual_infos_iterator_t

Get the next element in the iterator. The member rem is decreased by one. The member data points to the next element. The member index is increased by sizeof(xcb_dbe_visual_infos_t)

References xcb_generic_iterator_t::data.

Referenced by xcb_dbe_visual_infos_end().